import sys
import os
import copy

from multiprocessing import Pool

sys.path.append("../../")
from ressoft.utils.pvalue_utlis import hyperTestPvalue

from ressoft.utils.stats_utils import *
from ressoft.utils.generator import choose
from ressoft.utils.pred_utils import *
from ressoft.utils.input_utils import *
from ressoft.utils.names_utils import *
from ressoft.utils.output import *

def readParameters(param_tab):
    parameters = {}
    for param_el in param_tab:
        tokens = param_el.split("=")
        if len(tokens)==2:
            key = tokens[0]
            value = tokens[1]
            parameters[key] = value
        
    return parameters


parameters = readParameters(sys.argv)
species = "sta_plas8"

phase = 0
input_dir = os.path.abspath("../../../data_input/"+species+"_res/")+"/"
output_dir = os.path.abspath("../../../data_output/"+species+"_out/")+"/"

input_fh = open(input_dir + "strains-all.txt")
strains = readStrains(input_fh)
input_fh.close()

def readCCPresence(cluster_fh, strains):
    input_lines = cluster_fh.readlines()
    cc_presence = {}
    
    if len(input_lines) == 0:
        return None
    else:
        for line in input_lines:
            tokens = line.split()
            if tokens[3] in ["+", "-"]:
                #print("XXX", tokens0)
                strain_id = tokens[1]
                cc_id = tokens[0]
                genome_id = tokens[4]
                gene_id = tokens[5]
                if not cc_id in cc_presence:
                    cc_presence[cc_id] = {}
                if not strain_id in cc_presence[cc_id]:
                    cc_presence[cc_id][strain_id] = {}
                if not genome_id in cc_presence[cc_id][strain_id]:
                    cc_presence[cc_id][strain_id][genome_id] = set([])
                cc_presence[cc_id][strain_id][genome_id].add(gene_id)
    return cc_presence
            #return readClusters1(input_lines, strains)
def readPlasmidMapping(input_fh):
    plasmid_mapping = {}
    for line in input_fh.readlines():
        if not line:
            continue
        tokens = line.split()
        if len(tokens) < 2:
            continue
        plasmid_id = tokens[0]
        strain_id = tokens[1]
        if not plasmid_id in plasmid_mapping:
            plasmid_mapping[plasmid_id] = strain_id
    return plasmid_mapping

cluster_fh = open(input_dir + "conn_comp-det-"+str(phase)+".txt")
cc_presence = readCCPresence(cluster_fh, strains)
cluster_fh.close()

   
input_fh = open(input_dir + "plasmids.txt")
plasmid_map = readPlasmidMapping(input_fh)
input_fh.close()   

for cc_id in cc_presence:
    if cc_id in ["2400"]:
        for strain_id in cc_presence[cc_id]:
            for genome_id in cc_presence[cc_id][strain_id]:
                if genome_id in plasmid_map:
                    print("PLASMID", cc_id, strain_id, cc_presence[cc_id][strain_id][genome_id])
                else:
                    print("GENOME", cc_id, strain_id, cc_presence[cc_id][strain_id][genome_id])
                    
                    
