#install.packages()
require(graphics); require(grDevices); require(corrgram); require(corrplot)

#data_fn = paste(species_id, "_out/r_subset/", drug_name, ".txt", sep = "")
dataset = "mtb79"
data_fn = paste(dataset, "/data_available_corr.txt", sep="")
data = read.table(data_fn, header=TRUE, sep="\t")
#data = data[,-1]

x11()
corrgram(data, order=TRUE, lower.panel=panel.shade, 
		upper.panel=NULL, text.panel=panel.txt, 
		main="Drug resistance profile correlations", cex=1.5)

data_mat = t(as.matrix(data[,c(2,3,4)]))
colnames(data_mat) <- data[,1]

par(mar=c(12,8,1,1), oma=c(0,0,1,1), mgp=c(5,5,0))
x11()
barplot(data_mat, col=c("green", "red", "grey"), cex=0.8, cex.lab=1.5, cex.axis=1.5, cex.main=1.5, cex.sub=1.5, las=2, ylab="number of strains")
axis(1, at=3*1:3-1, labels=data[,1], las=2, cex.axis=1.5, cex.lab=2.5, cex.sub=2.5, cex=2.5)
legend(34, 1.05, c("PATRIC annotations", "PATRIC annotations after eCAMBer"), cex=1.8,  bty="n", fill=c("green", "red"));
#barplot(data_mat2, col=c("green"), beside=TRUE)
#
#data_mat2 = t(as.matrix(data[,c(6,9,8)]))
#colnames(data_mat2) <- data[,1]
#
#barplot(data_mat2, col=c("red", "green", "blue"))



#barplot(data_mat, col=c("red", "brown", "green", "blue", "orange"),main=paste("Method: ", m, sep = " "))
#legend("topleft", c("TP", "TN", "FP", "FN", "NO"), cex=0.6,  bty="n", fill=c("red", "brown", "green", "blue", "orange"));
