install.packages("corrgram")
require(graphics); require(grDevices); require(corrgram)

#data_fn = paste(species_id, "_out/r_subset/", drug_name, ".txt", sep = "")
dataset = "../camber-pred/datasets/broad_mtb"
drug_name="Rifampicin"
#data_fn = paste(dataset, "/det_bin_comb_ranks/",drug_name,"/FINAL7_S.txt", sep="")
data_fn = paste(dataset, "/det_bin_comb/",drug_name,"/FINAL7_S.txt", sep="")
data = read.table(data_fn, header=TRUE, sep="\t")

x11()
corrgram(data[,c("odds_ratio", "mi", "wsupport", "tscore")], order=TRUE, lower.panel=panel.shade, 
		upper.panel=NULL, text.panel=panel.txt, 
		main="Drug resistance core rankings correlations", cex=1.5)

#corrgram(data[,c("odds_ratio", "mi", "wsupport", "tscore", "ranks_sum_score")], order=TRUE, lower.panel=panel.shade, 
#		upper.panel=NULL, text.panel=panel.txt, 
#		main="Drug resistance core rankings correlations", cex=1.5)

plot(data[,"wsupport"], data[,"tscore"])

data[,"ranks_sum_score"]

#summary(data[,c("tscore", "mi","odds_ratio", "wsupport", "ranks_sum_score")])
#summary(data_a[,c("tscore", "mi","odds_ratio", "wsupport", "ranks_sum_score")])
#summary(data_h[,c("tscore", "mi","odds_ratio", "wsupport", "ranks_sum_score")])


cutoff = 100

data_h_acc = (data_h[,"tscore"] < cutoff) + (data_h[,"mi"] < cutoff) + (data_h[,"odds_ratio"] < cutoff) + (data_h[,"wsupport"] < cutoff) + (data_h[,"ranks_sum_score"] < cutoff)
data_h_top = data_h[data_h_acc >= 5,]
summary(data_h_top[,c("tscore", "mi","odds_ratio", "wsupport", "ranks_sum_score")])

data_a_acc = (data_a[,"tscore"] < cutoff) + (data_a[,"mi"] < cutoff) + (data_a[,"odds_ratio"] < cutoff) + (data_a[,"wsupport"] < cutoff) + (data_a[,"ranks_sum_score"] < cutoff)
data_a_top = data_a[data_a_acc >= 5,]
summary(data_a_top[,c("tscore", "mi","odds_ratio", "wsupport", "ranks_sum_score")])
