#install.packages()
require(graphics); require(grDevices); require(calibrate)

#data_fn = paste(species_id, "_out/r_subset/", drug_name, ".txt", sep = "")
dataset = "datasets/broad_mtb"
data_fn = paste(dataset, "/ranks_bin_genes/FINAL7_P.txt", sep="")
data = read.table(data_fn, header=TRUE, sep="\t")

#data = data[data[,"drug_name"] %in% c("Isoniazid", "Rifampicin", "Pyrazinamide", "Ethionamide", "Streptomycin"),]
#data = data[data[,"drug_name"] %in% c("Rifampicin", "Pyrazinamide"),]

data_a = data[data[,"high"] == "Y" | data[,"all"] == "Y",]
data_h = data[data[,"high"] == "Y",]

#summary(data[,c("tscore", "mi","odds_ratio", "wsupport", "ranks_sum_score")])
#summary(data_a[,c("tscore", "mi","odds_ratio", "wsupport", "ranks_sum_score")])
#summary(data_h[,c("tscore", "mi","odds_ratio", "wsupport", "ranks_sum_score")])

x_lim=-50
y_lim=300

#gene_id = "Rv1908c"
#gene_id = "Rv3854c"
gene_id = "Rv1484"
score_id = "tmow"
drugs = "iso"

cutoff = 1020

pdf_fn = paste(dataset, "/figures/drug_sens_", drugs, "_", gene_id,"_", score_id,".pdf", sep="")
pdf(pdf_fn,width=18,height=10)

par(mfrow=c(2,2))

drug_names = c("Isoniazid", "Ethionamide", "Prothionamide")
for (drug_name in drug_names) {
	data_d = data[data[,"drug_name"]==drug_name,]
	data_dg = data_d[data_d[,"gene_id"]==gene_id,]
	
	data_dg_a = data_dg[data_dg[,"high"] == "Y" | data_dg[,"all"] == "Y",]
	data_dg_h = data_dg[data_dg[,"high"] == "Y",]
	
	scores_vec = sqrt(1.0/data_dg[,c(score_id)])
	scores_vec_a = sqrt(1.0/data_dg_a[,c(score_id)])
	scores_vec_h = sqrt(1.0/data_dg_h[,c(score_id)])
	
	plot(data_dg[,c("position")], scores_vec, col="black", pch=16, xlim=c(x_lim,y_lim), main=drug_name, xlab="position", ylab=paste("score value: ",score_id, sep=""), ylim=c(0,1))
	points(data_dg_a[,c("position")], scores_vec_a, col="blue", pch=16)
	points(data_dg_h[,c("position")], scores_vec_h, col="red", pch=16)
	textxy(data_dg[,c("position")], scores_vec, labs=data_dg[,c("position")])
}

dev.off()
