#install.packages()
require(graphics); require(grDevices); require(stringr)

#data_fn = paste(species_id, "_out/r_subset/", drug_name, ".txt", sep = "")
dataset = "datasets/broad_mtb"
data_fn = paste(dataset, "/ranks_bin_genes/FINAL7_P.txt", sep="")
data_tmp = read.table(data_fn, header=TRUE, sep="\t")

statesCount <- function(states) {
	(nchar(as.character(states)) + 1) / 2
}

data_tmp["states_count"] <- sapply(data_tmp[, "non_ref_states_broad"], statesCount)
data = data_tmp[with(data_tmp, order(data_tmp[,"tmow"])), ]

data_a = data[data[,"high"] == "Y" | data[,"all"] == "Y",]
data_h = data[data[,"high"] == "Y",]

dimnames = list(cutoffs, scores)
data_h_means = matrix(nrow=length(cutoffs), ncol=length(scores), dimnames=dimnames)

drug_pairs = list(list("Rifampicin", "Rv0667"), list("Ethambutol", "Rv3795"),
		list("Ciprofloxacin", "Rv0006"), list("Isoniazid", "Rv1908c"),
		list("Streptomycin", "Rvnr01"), list("Pyrazinamide", "Rv2043c")
		)

		pdf_fn = paste(dataset, "/figures/scores_variants.pdf", sep="")
		pdf(pdf_fn,width=18,height=10)
par(mfrow=c(3,2))
for( drug_pair in drug_pairs) {

	drug_name = drug_pair[1]
	gene_id = drug_pair[2]
	
	data_d = data[data[,"drug_name"]==drug_name,]
	data_dg = data_d[data_d[,"gene_id"]==gene_id,]
	
	data_dg_a = data_dg[data_dg[,"high"] == "Y" | data_dg[,"all"] == "Y",]
	data_dg_h = data_dg[data_dg[,"high"] == "Y",]
	
	colors = c()
	for(i in seq(length(data_dg[,"high"]))) {
		if (data_dg[i,"high"] == "Y") {
			colors = c(colors, "red")
		} else if (data_dg[i,"high"] == "Y" | data_dg[i,"all"] == "Y"){
			colors = c(colors, "blue")
		} else{
			colors = c(colors, "black")
		}
	}

	plot(data_dg[, "states_count"], main=paste(drug_name, ", ", gene_id, sep=" "), xlab="Mutation ranking", ylab="Number of variants", pch=16, col=colors)
	textxy(seq(length(data_dg[, "states_count"])), data_dg[, "states_count"], labs=data_dg[,c("position")])
}

dev.off()

