#install.packages()
require(graphics); require(grDevices);

#data_fn = paste(species_id, "_out/r_subset/", drug_name, ".txt", sep = "")
dataset = "datasets/broad_mtb/expP/analysis/"
data_fn = paste(dataset, "/tbdb_scores_P_all.txt", sep="")
data = read.table(data_fn, header=TRUE, sep="\t")
db_type = "high"
#data_all = data[data[,"drug_name"]!="Pyrazinamide",]
data_all = data
data_all_a = data_all[data_all[,"high"] == "Y" | data_all[,"all"] == "Y",]
data_all_h = data_all[data_all[,"high"] == "Y",]

good_count = length(data_all[data_all[,"high"] == "Y" | data_all[,db_type] == "Y", "mi"])

scolor = c()
scolor[["norm_mtmow"]] = "green"
scolor[["norm_tscore"]] = "blue"
scolor[["norm_mtscore"]] = "lightblue"
scolor[["norm_tor"]] = "lightblue"
scolor[["norm_tmi"]] = "lightblue"
scolor[["norm_wsupport"]] = "black"
scolor[["norm_rand_wsupport"]] = "grey"
scolor[["norm_or"]] = "red"
scolor[["norm_mi"]] = "orange"
scolor[["norm_tmi"]] = "pink"
scolor[["norm_tor"]] = "pink"
scolor[["norm_stor"]] = "pink"
scolor[["norm_tmow"]] = "yellow"
scores_desc = c()


x11()
plot(c(), xlab="recall", ylab="precission", xlim=c(0.0,1.0), ylim=c(0.0, 1.0))
lwdc = 2.5

for (score_name in names(scolor)) {
	area = 0.0
	ranks_sel = data_all[order(data_all[score_name], data_all[db_type]), c(score_name, "all", "high")]
	
	n = length(ranks_sel[,score_name])
	prec = c()
	recall = c()
	
	tp = 0
	last_rank = ranks_sel[n, score_name]
	
	for (i in 1:n) {
		rank = ranks_sel[n-i+1, score_name]
		if (ranks_sel[n-i+1, db_type] == "Y" | ranks_sel[n-i+1, "high"] == "Y") {
			tp = tp + 1
		}
		fp = i - tp
		if (rank != last_rank) {
			if (length(prec) == 0) {
				prec = c(prec, tp / i)
				recall = c(recall, 0.0)
			}
			prec = c(prec, tp / i)
			recall = c(recall, tp / good_count)
			k = length(prec)
			area = area + 0.5*(prec[k] + prec[k-1])*(recall[k]-recall[k-1])
		}
		last_rank = ranks_sel[n-i+1, score_name]
	}
	lwdc = lwdc - 0.05
	scores_desc = c(scores_desc, paste(score_name, " [AUC=" , round(area,2) , "]", sep=""))
	points(prec~recall, col=scolor[[score_name]], pch=18, lwd=lwdc, type="l", xlim=c(0.0,1.0), ylim=c(0.0, 1.0))
}

legend("topright", fill=scolor, legend = scores_desc)
