#install.packages()
require(graphics); require(grDevices);

#data_fn = paste(species_id, "_out/r_subset/", drug_name, ".txt", sep = "")
prefix = "D:/Dropbox/Dropbox/gwadrib/"
dataset = paste(prefix,"datasets/broad_mtb/exP/stats/", sep="")

scolor = c()
scolor[["n.or"]] = "red"
scolor[["n.mi"]] = "orange"
scolor[["n.ts"]] = "blue"
scolor[["n.ws"]] = "black"
scolor[["n.r.cct"]] = "green"

#score = "n.or"

input_fn = paste(dataset, "/",score,".txt", sep="")
data = read.table(data_fn, header=FALSE, sep="\t")


x11()
plot(c(), xlab="recall", ylab="precission", xlim=c(0.0,1.0), ylim=c(0.0, 1.0))

for (score_name in names(scolor)) { 
	area = 0.0
	
	n = length(ranks_sel[,score_name])
	prec = c()
	recall = c()
	
	tp = 0
	last_rank = ranks_sel[n, score_name]
	
	for (i in 1:n) {
		rank = ranks_sel[n-i+1, score_name]
		if (ranks_sel[n-i+1, db_type] == "Y" | ranks_sel[n-i+1, "high"] == "Y") {
			tp = tp + 1
		}
		fp = i - tp
		if (rank != last_rank) {
			if (length(prec) == 0) {
				prec = c(prec, tp / i)
				recall = c(recall, 0.0)
			}
			prec = c(prec, tp / i)
			recall = c(recall, tp / good_count)
			k = length(prec)
			area = area + 0.5*(prec[k] + prec[k-1])*(recall[k]-recall[k-1])
		}
		last_rank = ranks_sel[n-i+1, score_name]
	}

	scores_desc = c(scores_desc, paste(score_name, " [AUC=" , round(area,2) , "]", sep=""))
	points(prec~recall, col=scolor[[score_name]], pch=18, lwd=1.5, type="l", xlim=c(0.0,1.0), ylim=c(0.0, 1.0))
}

legend("topright", fill=scolor, legend = scores_desc)
