
#s
par(mfrow=c(3,3))

for (drug_name in c("Rifampicin", "Isoniazid", "Pyrazinamide", "Levofloxacin", "Moxifloxacin", "Ciprofloxacin", "Ofloxacin", "Ethambutol", "Streptomycin")) {
	plot(c(), xlab="recall", ylab="precission", xlim=c(0.0,1.0), ylim=c(0.0, 1.0), main=drug_name)
	
	data_all = data[data[,"drug_name"]==drug_name,]
	data_all_a = data_all[data_all[,"high"] == "Y" | data_all[,"all"] == "Y",]
	data_all_h = data_all[data_all[,"high"] == "Y",]
	
	good_count = length(data_all[data_all[,"high"] == "Y" | data_all[,db_type] == "Y", "mi"])
	
	scolor = c()
	scolor[["n.ts"]] = "blue"
	scolor[["n.ws"]] = "black"
	scolor[["n.or"]] = "red"
	scolor[["n.mi"]] = "orange"
	
	for (score_name in names(scolor)) { 
		area = 0.0
		ranks_sel = data_all[order(data_all[score_name], data_all[db_type]), c(score_name, "all", "high")]
		
		n = length(ranks_sel[,score_name])
		prec = c(1.0)
		recall = c(0.0)
		
		tp = 0
		last_rank = ranks_sel[n, score_name]
		
		for (i in 1:n) {
			rank = ranks_sel[n-i+1, score_name]
			if (ranks_sel[n-i+1, db_type] == "Y" | ranks_sel[n-i+1, "high"] == "Y") {
				tp = tp + 1
			}
			fp = i - tp
			if (rank != last_rank) {
				prec = c(prec, tp / i)
				recall = c(recall, tp / good_count)
				k = length(prec)
				area = area + 0.5*(prec[k] + prec[k-1])*(recall[k]-recall[k-1])
			}
			last_rank = ranks_sel[n-i+1, score_name]
		}
		print(paste(drug_name, score_name, area))
		points(prec~recall, col=scolor[[score_name]], pch=18, lwd=2.0, type="l", xlim=c(0.0,1.0), ylim=c(0.0, 1.0))
	}
}
