#install.packages()
require(graphics); require(grDevices);

#data_fn = paste(species_id, "_out/r_subset/", drug_name, ".txt", sep = "")
dataset = "datasets/broad_mtb/expP/analysis/"
data_fn = paste(dataset, "/tbdb_scores_P_all.txt", sep="")
data = read.table(data_fn, header=TRUE, sep="\t")
db_type = "high"
data_all = data[data[,"drug_name"]=="Rifampicin",]
#data_all = data[data[,"drug_name"] %in% c("Rifampicin", "Isoniazid", "Ethambutol", "Ofloxacin", "Ciprofloxacin"),]
data_all_a = data_all[data_all[,"high"] == "Y" | data_all[,"all"] == "Y",]
data_all_h = data_all[data_all[,"high"] == "Y",]

good_count = length(data_all[data_all[,"high"] == "Y" | data_all[,db_type] == "Y", "mi"])

score_name = "pv.tscore"
ranks_sel = data_all[order(data_all[score_name]), c(score_name, "all", "high")]
n = length(ranks_sel[,score_name])
prec = c()
recall = c()

tp = 0
for (i in 1:n) {
	rank = ranks_sel[i, score_name]
	if (ranks_sel[i, db_type] == "Y" | ranks_sel[i, "high"] == "Y") {
		tp = tp + 1
	}
	fp = i - tp
	prec = c(prec, tp / i)
	recall = c(recall, tp / good_count)	
}

x11()
plot(prec~recall, col= "blue", pch=17, xlim=c(0.0,1.0), ylim=c(0.0, 1.0))

score_name = "pv.wsupport"
ranks_sel = data_all[order(data_all[score_name]), c(score_name, "all", "high")]
n = length(ranks_sel[,score_name])
prec = c()
recall = c()

tp = 0
for (i in 1:n) {
	rank = ranks_sel[i, score_name]
	if (ranks_sel[i, db_type] == "Y" | ranks_sel[i, "high"] == "Y") {
		tp = tp + 1
	}
	fp = i - tp
	prec = c(prec, tp / i)
	recall = c(recall, tp / good_count)	
}
points(prec~recall, col= "black", pch=18, xlim=c(0.0,1.0), ylim=c(0.0, 1.0))

score_name = "pv.odds_ratio"
ranks_sel = data_all[order(data_all[score_name]), c(score_name, "all", "high")]
n = length(ranks_sel[,score_name])
prec = c()
recall = c()

tp = 0
for (i in 1:n) {
	rank = ranks_sel[i, score_name]
	if (ranks_sel[i, db_type] == "Y" | ranks_sel[i, "high"] == "Y") {
		tp = tp + 1
	}
	fp = i - tp
	prec = c(prec, tp / i)
	recall = c(recall, tp / good_count)	
}
points(prec~recall, col= "red", pch=19, xlim=c(0.0,1.0), ylim=c(0.0, 1.0))

score_name = "pv.mi"
ranks_sel = data_all[order(data_all[score_name]), c(score_name, "all", "high")]
n = length(ranks_sel[,score_name])
prec = c()
recall = c()

tp = 0
for (i in 1:n) {
	rank = ranks_sel[i, score_name]
	if (ranks_sel[i, db_type] == "Y" | ranks_sel[i, "high"] == "Y") {
		tp = tp + 1
	}
	fp = i - tp
	prec = c(prec, tp / i)
	recall = c(recall, tp / good_count)	
}
points(prec~recall, col= "orange", pch=20, xlim=c(0.0,1.0), ylim=c(0.0, 1.0))

score_name = "pv.tmow"
ranks_sel = data_all[order(data_all[score_name]), c(score_name, "all", "high")]
n = length(ranks_sel[,score_name])
prec = c()
recall = c()

tp = 0
for (i in 1:n) {
	rank = ranks_sel[i, score_name]
	if (ranks_sel[i, db_type] == "Y" | ranks_sel[i, "high"] == "Y") {
		tp = tp + 1
	}
	fp = i - tp
	prec = c(prec, tp / i)
	recall = c(recall, tp / good_count)	
}
points(prec~recall, col= "yellow", pch=20, xlim=c(0.0,1.0), ylim=c(0.0, 1.0))
