#install.packages()
require(graphics); require(grDevices);

#data_fn = paste(species_id, "_out/r_subset/", drug_name, ".txt", sep = "")
dataset = "datasets/broad_mtb"
data_fn = paste(dataset, "/ranks_bin_genes_ranks/FINAL7_P.txt", sep="")
data = read.table(data_fn, header=TRUE, sep="\t")

#data = data[data[,"drug_name"] %in% c("Isoniazid", "Rifampicin", "Pyrazinamide", "Ethionamide", "Streptomycin"),]
#data = data[data[,"drug_name"] %in% c("Rifampicin", "Pyrazinamide"),]

data_a = data[data[,"high"] == "Y" | data[,"all"] == "Y",]
data_h = data[data[,"high"] == "Y",]

#summary(data[,c("tscore", "mi","odds_ratio", "wsupport", "ranks_sum_score")])
#summary(data_a[,c("tscore", "mi","odds_ratio", "wsupport", "ranks_sum_score")])
#summary(data_h[,c("tscore", "mi","odds_ratio", "wsupport", "ranks_sum_score")])

cutoff = 1060

data_a_acc = (data_a[,"tscore"] < cutoff) + (data_a[,"mi"] < cutoff) + (data_a[,"odds_ratio"] < cutoff) + (data_a[,"wsupport"] < cutoff)
data_a_top = data_a[data_a_acc >= 4,]
summary(data_a_top[,c("tscore", "mi","odds_ratio", "wsupport", "tmow", "tmo", "to", "tow")])

data_h_acc = (data_h[,"tscore"] < cutoff) + (data_h[,"mi"] < cutoff) + (data_h[,"odds_ratio"] < cutoff) + (data_h[,"wsupport"] < cutoff)
data_h_top = data_h[data_h_acc >= 4,]
summary(data_h_top[,c("tscore", "mi","odds_ratio", "wsupport", "tmow", "tmo", "to", "tow")])

window_size = 1000

pdf_fn = paste(dataset, "/figures/scores_cmp_200.pdf", sep="")
pdf(pdf_fn,width=18,height=10)

plot(data_h_top[,c("tmow")], data_h_top[,c("tscore")], xlab="tmow", ylab="scores", col="blue", pch=16, xlim=c(0,window_size), ylim=c(0,window_size))
points(data_h_top[,c("tmow")],data_h_top[,c("mi")], col="orange", pch=17)
points(data_h_top[,c("tmow")],data_h_top[,c("odds_ratio")], col="red", pch=18)
points(data_h_top[,c("tmow")],data_h_top[,c("wsupport")], col="black", pch=19)
points(data_h_top[,c("tmow")],data_h_top[,c("tmow")], col="yellow", pch=20)
#legend("topleft", c("tree score", "mutual information", "odds ratio", "weighted support", "tmow"), cex=1.6,  bty="n", fill=c("blue", "orange", "red", "black", "yellow"));
dev.off()
