#install.packages()
require(graphics); require(grDevices);

#data_fn = paste(species_id, "_out/r_subset/", drug_name, ".txt", sep = "")
dataset = "datasets/broad_mtb"
data_fn = paste(dataset, "/ranks_bin_genes_ranks/FINAL7_P.txt", sep="")
data = read.table(data_fn, header=TRUE, sep="\t")

#data = data[data[,"drug_name"] %in% c("Isoniazid", "Rifampicin", "Pyrazinamide", "Ethionamide", "Streptomycin"),]
#data = data[data[,"drug_name"] %in% c("Rifampicin", "Pyrazinamide"),]

data_a = data[data[,"high"] == "Y" | data[,"all"] == "Y",]
data_h = data[data[,"high"] == "Y",]

#summary(data[,c("tscore", "mi","odds_ratio", "wsupport", "ranks_sum_score")])
#summary(data_a[,c("tscore", "mi","odds_ratio", "wsupport", "ranks_sum_score")])
#summary(data_h[,c("tscore", "mi","odds_ratio", "wsupport", "ranks_sum_score")])

cutoffs = seq(2, 1000)
scores = c("tscore", "mi", "odds_ratio", "wsupport", "tmow")

dimnames = list(cutoffs, scores)
data_h_means = matrix(nrow=length(cutoffs), ncol=length(scores), dimnames=dimnames)

pdf_fn = paste(dataset, "/figures/scores_cmp_means_200.pdf", sep="")
pdf(pdf_fn,width=18,height=10)
par(mfrow=c(2,2))

for (thr in c(1,2,3,4)) {
	for (cutoff in cutoffs) {
		data_h_acc = (data_h[,"tscore"] < cutoff) + (data_h[,"mi"] < cutoff) + (data_h[,"odds_ratio"] < cutoff) + (data_h[,"wsupport"] < cutoff)
		data_h_top = data_h[data_h_acc >= thr,]
		for (score in scores) {
			data_h_means[as.character(cutoff), score] = mean(data_h_top[, score])
		}
	}
	
	plot(cutoffs, data_h_means[,"tscore"], pch=16, xlim=c(0,200), ylim=c(0,100), col="blue", xlab="cutoff", ylab="avg. ranking", main=paste("Mutations selected by ",as.character(thr)," scores",sep=""))
	points(cutoffs, data_h_means[,"mi"], pch=17, col="orange")
	points(cutoffs, data_h_means[,"odds_ratio"], pch=18, col="red")
	points(cutoffs, data_h_means[,"wsupport"], pch=19, col="black")
	points(cutoffs, data_h_means[,"tmow"], pch=20, col="yellow")

	legend("topleft", c("tree score", "mutual information", "odds ratio", "weighted support", "tmow"), cex=1.6,  bty="n", fill=c("blue", "orange", "red", "black", "yellow"));
}
dev.off()

