import sys
import os
import time
import math
import shutil
import random
import multiprocessing
from multiprocessing import Pool

sys.path.append("../../")

from drsoft.utils.gwamar_params_utils import *
from drsoft.utils.gwamar_utils import ensure_dir


if __name__ == '__main__':
    print("cmp3_draw_figures.py: Start.")
    
    parameters = overwriteParameters(sys.argv)
    parameters = readParameters()
    
    dataset = parameters["D"]
    cmp_dir = parameters["RESULTS_CMP_DIR"]
    cmp_assocs_dir = parameters["RESULTS_CMP_ASSOCS_DIR"]
    Rscript_dir = parameters["GWAMAR_SRC"] + "visR/accuracy/"

    scores_p = parameters["SCORES"].split(",")

    scores_list = []
    for score in scores_p:
        score_fn = score + ".txt"
        scores_list.append(score)
    scores_arg = ','.join(scores_list)

    subsets = parameters.get("SUBSETS", "s3_1000")
    stats = parameters.get("STATS", "auc,auc10,auc20")

    rparams1 = " ".join([dataset, parameters["MT"], subsets, parameters["GWAMAR_PATH"], scores_arg, stats])
    print(rparams1)
    command = "Rscript " + Rscript_dir + "/auc_barplots.R " + rparams1
    print(command)
    os.system(command)
    print("cmp3_draw_figures.py: Finished.")
   