import sys
import os
import copy
from multiprocessing import Pool

sys.path.append("../../")

from drsoft.utils.gwamar_params_utils import *
from drsoft.utils.gwamar_res_io_utils import saveResistanceProfiles
from drsoft.utils.gwamar_strains_io_utils import readStrains
from drsoft.structs.resistance_profile import ResistanceProfile


def loadGeoData(input_fh):
    geo_data_map = {}

    lines = input_fh.readlines()
    for line in lines:
        print(line)
        line = line.strip()
        if line.startswith("#") or len(line) < 2:
            continue
        tokens = line.split("\t")

        if len(tokens) < 1: continue
        elif len(tokens) in [1,2]:
            country = "Unknown"
            continent = "Unknown"
        else:
            strain_id = tokens[1]
            country = tokens[1]
            continuent = tokens[2]
            geo_data_map[strain_id]= (country, continent)
    return geo_data_map
        
# def drugsList(res_data):
#     drugs_map = {}
#     for (strain_id, drug_name) in res_data:
#         if not drug_name in drugs_map:
#             drugs_map[drug_name] = 0
#         drugs_map[drug_name] += 1
#     drugs_list = sorted(drugs_map, key=lambda drug_name:-drugs_map[drug_name])
#     return drugs_list

# def strainsList(res_data):
#     strains_set = set([])
#     for (strain_id, drug_name) in res_data:
#         strains_set.add(strain_id)
#     strains_list = sorted(strains_set)
#     return strains_list


# def generateResData(output_fh, res_data):
#     tls = []

#     drugs_list = drugsList(res_data)
#     strains_list = strainsList(res_data)

#     k = len(drugs_list)
#     n = len(strains_list)

#     for drug_name in drugs_list:
#         tl = drug_name + "\t"

#         strains_res = []
#         strains_int = []
#         strains_susc = []

#         for strain_id in strains_list:
#             res_data_infos = res_data.get((strain_id, drug_name), [])
#             res_status = determineResistance(res_data_infos)
#             if res_status == "R": strains_res.append(strain_id)
#             elif res_status == "I": strains_int.append(strain_id)
#             elif res_status == "S": strains_susc.append(strain_id)

#         for strain_id in sorted(strains_res): tl += strain_id + ";"
#         if len(strains_res) > 0: tl = tl[:-1] + "\t"
#         else: tl = tl + "\t"

#         for strain_id in sorted(strains_susc): tl += strain_id + ";"
#         if len(strains_susc) > 0: tl = tl[:-1] + "\t"
#         else: tl = tl + "\t"

#         for strain_id in sorted(strains_int): tl += strain_id + ";"
#         if len(strains_int) > 0: tl = tl[:-1]
#         else: tl = tl

#         if len(strains_res) > 5 and len(strains_susc) > 5:
#             tls.append(tl)

#     for tl in tls:
#         output_fh.write(tl + "\n")
#     return None

if __name__ == '__main__':
    dataset = "mtu"
    tree_ids= ["t1"]

    parameters = overwriteParameters(sys.argv)
    parameters = readParameters()
    
    gwamar_dir = parameters["GWAMAR_PATH"]
    input_dir = parameters["RES_DATA"] + dataset + "/"

    print("xxx")
    input_fh = open(input_dir + "/res-data.txt")
    geo_data = loadGeoData(input_fh)
    input_fh.close()
    print("yyy")

    for tree_id in tree_ids:
        output_fh = open(input_dir + "/geo-tree-"+tree_id+".dot", "w")
        generateGeoTrees(output_fh, res_data)
        output_fh.close()
        print("zzz")
