#install.packages()
require(graphics); require(grDevices); require(corrgram); require(corrplot)

#data_fn = paste(species_id, "_out/r_subset/", drug_name, ".txt", sep = "")
#dataset = "mtb79"
dataset = "sau439"
drug_name = "mecA_SAR0039_360"
#drug_name = "Streptomycin"
#gene_id = "rpoB_Rv0667"
#gene_id = "katG_Rv1908c"
#gene_id = "phrB_SAR0744"
#gene_id = "dnaX_SAR0477"
#gene_id = "rrl_Rvnr02"
#gene_id = "rpsL_Rv0682"
score = "odds_ratio"
#score = "mi"

data_fn = paste( "datasets/", dataset, "/det_bin_show_full/",drug_name,"/FINAL7_P.txt", sep="")
data = read.table(data_fn, header=TRUE, sep="\t")

data_t = data[, c("gene_id", "position", score)]
#data_t = data_t[with(data_t, order(data_t[,"gene_id"])), ]
data_t = data_t[with(data_t, order(data_t[,"position"])), ]

gene_color_map = c()
gene_colors = c()
gene_id_colors = c()
for (gene_id in data_t[, "gene_id"]) {
	if (!gene_id %in% names(gene_color_map)) { 
		gene_color_map[[gene_id]] <- rgb(runif(1),runif(1),runif(1))
	}
	gene_colors = c(gene_colors, gene_color_map[[gene_id]])
}
for (gene_id in names(gene_color_map)) {
	gene_id_colors = c(gene_id_colors, gene_color_map[[gene_id]])
}

x11()
plot(data_t[,3], pch=16, type="h", lwd=2)
#plot(data_t[,3], pch=16, type="h", lwd=2, xlim=c(length(data_t[,1])-20, length(data_t[,1])),ylim=c(0,100))
points(data_t[,3], pch=16, cex=1.0, col=gene_colors)
legend("topright", names(gene_color_map), ncol=2, cex=0.7,  bty="n", fill=gene_id_colors);

